/*
 * Copyright (C) 2003 Jean-Philippe Hergott <hergott@free.fr>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <errno.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"



void
xcave_init(gint argc, gchar *argv[])
{
	GtkWidget	*xcave;

    XCAVE_DEBUG_B;

#if (defined DEBUG_LEVEL_2)
	GTimer		*gtimer;
	gulong		*ms;
	printf("xcave_init:time:0:\n");
	gtimer = g_timer_new();
#endif

	add_support_directory("/usr/local/share/pixmaps/xcave");

#if (defined DEBUG_LEVEL_2)
	printf("xcave_init:time add_support_directory:%f:\n",g_timer_elapsed(gtimer,ms));
#endif

    add_support_directory("/usr/share/pixmaps/xcave");
#if (defined DEBUG_LEVEL_2)
	printf("xcave_init:time add_support_directory:%f:\n",g_timer_elapsed(gtimer,ms));
#endif

	read_xcaverc();
#if (defined DEBUG_LEVEL_2)
	printf("xcave_init:time read xcaverc:%f:\n",g_timer_elapsed(gtimer,ms));
#endif

	/* 
	* variables initialisation 
	*/
	
	{
	time_t now;
	struct tm * stnow;
	
	now=time(&now);
	stnow=localtime(&now);
	nowan=stnow->tm_year+1900;
	}
	
	
	/*
	* The following code was added by Glade to create one of each component
	* (except popup menus), just so that you see something after building
	* the project. Delete any components that you don't want shown initially.
	*/
	xcave = create_xcave ();
	if ( strlen(WIDTH) != 0 && strlen (WIDTH) != 0 ) {
	 gtk_window_set_default_size (GTK_WINDOW (xcave), atoi(WIDTH), atoi(HEIGHT));
	}
	
	gtk_widget_show (xcave);

	{
	GtkWidget			*TreeView;
	GtkTreeSelection 	*selection;
	GtkTreeModel     	*ModelView;
	GtkTreeIter      	selected_row;

	TreeView = lookup_widget(window_xcave,"TreeView");
		
	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(TreeView));
	g_assert(gtk_tree_selection_get_mode(selection) == GTK_SELECTION_SINGLE);
	if (gtk_tree_selection_get_selected(selection, &ModelView, &selected_row)){
		gtk_tree_selection_unselect_iter(selection,&selected_row);
	}
	
	g_signal_connect ((gpointer) TreeView, "cursor_changed",
					G_CALLBACK (on_TreeView_cursor_changed),
					NULL);
	}

  gtk_main ();

  write_xcaverc ();

    XCAVE_DEBUG_B;

  return ;
}


gint
main (gint argc,
      gchar *argv[])
{

#ifdef ENABLE_NLS
	bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");	
	/* Je ne comprends pas le pb d'accent lié à UTF-8 ... en attendant */
	// bind_textdomain_codeset (GETTEXT_PACKAGE, "ISO-8859-15");
	textdomain (GETTEXT_PACKAGE);
#endif

  gtk_init(&argc, &argv);

  add_support_directory(PACKAGE_DATA_DIR "/" PACKAGE "");
  
  xcave_init(argc, argv);

  return 0;
}
