/***************************************************************************
 *            xcave_fileselection.c
 *
 *  Mon Dec 13 22:19:24 2004
 *  Copyright  2004  Jean-Philippe Hergott
 *  xcave@free.fr
 ****************************************************************************/
 
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
  
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <errno.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

void
on_window_config_button_file_clicked   (GtkButton       *button,
                                        gpointer         user_data)
{
    XCAVE_DEBUG_B;

    window_fileselection_stock = create_fileselection_stock();
    gtk_file_selection_set_filename(GTK_FILE_SELECTION(window_fileselection_stock), DBPATH);
    gtk_widget_show (window_fileselection_stock);

    XCAVE_DEBUG_E;
}


void
on_fileselection_stock_destroy         (GtkObject       *object,
                                        gpointer         user_data)
{
  gtk_object_destroy (GTK_OBJECT (window_fileselection_stock));

}

void
on_window_fileselection_stock_ok_button_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
	gchar *(buf) = (gchar*)gtk_file_selection_get_filename
							(GTK_FILE_SELECTION(window_fileselection_stock));

	gtk_entry_set_text (GTK_ENTRY (lookup_widget (window_config, "PathStock")), (gchar *) buf);

	if (strcasecmp(buf, DBPATH) != 0){
		strcpy(DBPATH,buf);
	  /*
	   * initialisation diverses et variees:
	   *   (GList) liste du stock
	   *   (GList) liste des country
	   *   (GList) liste des regions
	   *   (GList) liste des appellations
	   *   (GList) liste des cepages
	   */
		list_append_stock();
		
		list_append_rack();
		
		list_append_categ();
		list_append_country();
		list_append_region();
		list_append_appellation();
		list_append_cepage();
		
		list_country_append_stock();
		list_region_append_stock();
		list_appellation_append_stock();
		list_cepage_append_stock();
	
		list_country = g_list_sort(list_country,(GCompareFunc)cmp_country);
	
		/*
		 * need to update storeview and storelist
		 */
		GtkWidget		*treelist;
		GtkWidget		*treeview;
		GtkListStore	*storelist;
		GtkTreeStore	*storeview;
		
		treelist = lookup_widget(window_xcave,"TreeList");
		storelist	= (GtkListStore *) gtk_tree_view_get_model((GtkTreeView *)treelist);
		gtk_list_store_clear(storelist);
	
		treeview = lookup_widget(window_xcave,"TreeView");
		storeview	= (GtkTreeStore *) gtk_tree_view_get_model((GtkTreeView *)treeview);
		gtk_tree_store_clear(storeview);
		
		xcave_fill_model (storeview, storelist);
		
	}

	gtk_object_destroy (GTK_OBJECT (window_fileselection_stock));

}


void
on_window_fileselection_stock_cancel_button1_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_object_destroy (GTK_OBJECT (window_fileselection_stock));


}
